#include <conio.h>//cprintf, ...
#include <io.h>//read, ...
#include <fcntl.h>//O_BINARY, ...
#include <process.h>//exit
#include <string.h>//strupr
#include <ctype.h>//toupper
#include <dir.h>//findfirst, ...
#include <stdio.h>//sprintf
#include "types.h"
#include "wordtree.cpp"

 typedef char fNameStr[80];

 struct FileInfo {
  char Name[13];
 };//FileInfo

 const Word LoadBufferSize = 51200U;
 const Word SaveBufferSize = 51200U;

 const char CharList[] = {
  A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z};

 const char *ErrorMessages[4] = {
  "Nedostatek pameti !\0",
  "Chyba pri otevirani zdrojoveho souboru !\0",
  "Chyba pri otevirani ciloveho souboru !\0",
  "Soubor nenalezen !\0" };

 char IsError = 0;
 char **Args;
 fNameStr *ArgFile;
 int ArgCount;
 int fSource;
 int fDest;
 char fSourceOpen = 0;
 char fDestOpen = 0;
 FileInfo fSourceInfo, fDestInfo;
 Word LoadCount;
 Word SaveCount;
 Byte *LoadBuffer;
 Byte *SaveBuffer;
 Word LoadIndex;
 Word SaveIndex;
 char fLoadEnd;
 char fSourceEnd;
 char *OneWord = "";
 char WordLen;
 DWord LineIndex;
 char LineIndexUp;
 CWordTree WordTree;

void RestoreAll ()
{
 if (LoadBuffer != NULL) free (LoadBuffer);
 if (SaveBuffer != NULL) free (SaveBuffer);
 if (ArgFile != NULL) free (ArgFile);
 if (fSourceOpen) close (fSource);
 if (fDestOpen) close (fDest);
}//RestoreAll


void ErrorMsg (const char *text)
{
 cprintf ("\r\n"); cprintf (text);
 RestoreAll ();
 exit (1);
}//ErrorMsg


void InitSource ()
{
 LoadBuffer = (Byte *)malloc (LoadBufferSize);
 if (LoadBuffer == NULL) ErrorMsg (ErrorMessages[0]);
 fSourceOpen = 0;
 fSource = open (fSourceInfo.Name, O_RDONLY | O_BINARY);
 if (fSource == -1) ErrorMsg (ErrorMessages[1]); else fSourceOpen = 1;
 fLoadEnd = 0;
 fSourceEnd = 0;
 LoadIndex = 0;
}//InitSource

void FreeSource ()
{
 if (LoadBuffer != NULL) free (LoadBuffer);
 if (fSourceOpen) { close (fSource); fSourceOpen = 0; }//if
}//FreeSource

void InitDest ()
{
 SaveBuffer = (Byte *)malloc (SaveBufferSize);
 if (SaveBuffer == NULL) ErrorMsg (ErrorMessages[0]);
 fDestOpen = 0;
 fDest = open (fDestInfo.Name, O_CREAT | O_APPEND | O_WRONLY | O_BINARY);
 if (fDest == -1) ErrorMsg (ErrorMessages[2]); else fDestOpen = 1;
 SaveIndex = 0;
}//InitDest

void FreeDest ()
{
 if (SaveBuffer != NULL) free (SaveBuffer);
 if (fDestOpen) { close (fDest); fDestOpen = 0; }//if
}//FreeDest

void ReadSource ()
{
 LoadCount = read (fSource, LoadBuffer, LoadBufferSize);
 if (eof (fSource)) fLoadEnd = 1;
}//ReadSource

void WriteDest ()
{
 SaveCount = write (fDest, SaveBuffer, SaveIndex);
}//WriteDest

void CheckLoadBufferEmpty ()
{
 if ((LoadIndex == LoadCount) && (!fLoadEnd)) {
  ReadSource (); LoadIndex = 0;
 }//if
}//CheckLoadBufferEmpty

void CheckSaveBufferFull ()
{
 if (SaveIndex == SaveBufferSize) {
  WriteDest (); SaveIndex = 0;
 }//if
}//CheckSaveBufferFull

char IsLetter (char let)
{
 char ok = 0;
 char nextlet;
 for (int i = 0; i < MaxChars; i++)
  if (let == CharList[i]) ok = 1;
 if (!ok)
  if (let == 13) {
   nextlet = LoadBuffer[LoadIndex];
   LoadIndex++; CheckLoadBufferEmpty ();
   if (LoadIndex == LoadCount) fSourceEnd = 1;
   if (nextlet == 10) LineIndexUp++;
  }//if
 return ok;
}//IsLetter

void FindWord ()
{
 char letter;
 WordLen = 0;
 do {
  letter = LoadBuffer[LoadIndex];
  letter = toupper (letter);
  LoadIndex++; CheckLoadBufferEmpty ();
  if (LoadIndex == LoadCount) fSourceEnd = 1;
  if (IsLetter (letter)) {
   OneWord[WordLen] = letter;
   WordLen++;
  }//if
  else break;
  if (fSourceEnd) break;
 } while (1);
}//FindWord

char Convert (char *pole, DWord cislo)
{
 DWord k = 1000000000UL;
 char c ,i = 0;
 while (cislo != 0) {
  c = cislo / k;
  if (c) { pole[i] = c + '0'; i++; cislo -= c * k; }//if
  k /= 10;
 }//while
 if (!i) { i = 1; pole[0] = '0'; }//if
 return i;
}//Convert

void SaveWord (char *_word, char wordlen, DWord *list, DWord llen)
{
 for (int i = 0; i < wordlen; i++) {
  SaveBuffer[SaveIndex] = _word[i];
  SaveIndex++;
  CheckSaveBufferFull ();
 }//for
 SaveBuffer[SaveIndex] = ' ';
 SaveIndex++;
 CheckSaveBufferFull ();
 SaveBuffer[SaveIndex] = ':';
 SaveIndex++;
 CheckSaveBufferFull ();
 SaveBuffer[SaveIndex] = ' ';
 SaveIndex++;
 CheckSaveBufferFull ();
 char *linestr = "";
 for (int j = 0; j < llen; j++) {
  char num = Convert (linestr, list[j]);
  for (int k = 0; k < num; k++) {
   SaveBuffer[SaveIndex] = linestr[k];
   SaveIndex++;
   CheckSaveBufferFull ();
  }//for
  SaveBuffer[SaveIndex] = ' ';
  SaveIndex++;
  CheckSaveBufferFull ();
 }//for
 SaveBuffer[SaveIndex] = 13;
 SaveIndex++;
 CheckSaveBufferFull ();
 SaveBuffer[SaveIndex] = 10;
 SaveIndex++;
 CheckSaveBufferFull ();
}//SaveWord

void DoCrossRef ()
{
 LineIndexUp = 0;
 LineIndex = 0;
 do {
  FindWord ();
  if (WordLen != 0) WordTree.Insert (OneWord, WordLen, LineIndex);
  if (LineIndexUp) { LineIndex += LineIndexUp; LineIndexUp = 0; }//if
  if (fSourceEnd) break;
 } while (1);
}//DoCrossRef

void Process ()
{
 for (int i = 0; i < 13; i++)
  fSourceInfo.Name[i] = ArgFile[0][i];
 cprintf ("\r\nVytvarim soubor krizovych referenci ze souboru ");
 cprintf ("%s ... ", strupr (fSourceInfo.Name));
 InitSource ();
 ReadSource ();
 DoCrossRef ();
 FreeSource ();
 char drive[MAXDRIVE], dir[MAXDIR], file[MAXFILE], ext[MAXEXT];
 fnsplit (fSourceInfo.Name,drive,dir,file,ext);
 strcpy (ext, ".CRF");
 fnmerge (fDestInfo.Name,drive,dir,file,ext);
 InitDest ();
 WordTree.GoThrough (SaveWord);
 WriteDest ();
 FreeDest ();
 cprintf ("OK\r\n\r\n");
}//Process

void ProcessParams ()
{
 if (ArgCount < 2) { IsError = 1; return; };
 ArgFile = (fNameStr *)malloc (1);
 if (ArgFile == NULL) ErrorMsg (ErrorMessages[0]);
 int ok;
 ffblk foundfile;
 ok = findfirst (Args[1], &foundfile, 0);
 if (!ok)
  for (int i = 0; i < 13; i++)
   ArgFile[0][i] = foundfile.ff_name[i];
 else ErrorMsg (ErrorMessages[3]);
}//ProccessParams

void main (int argc, char *argv[])
{
 Args = argv;
 ArgCount = argc;
 ProcessParams ();
 if (!IsError) {
  Process ();
  RestoreAll ();
 }//if
 else
  cprintf ("\r\n  CROSSREF      Copyright (c) 1999 Jan Outrata"
           "\r\n"
           "\r\nPouziti:     CROSSREF <soubor>"
           "\r\n\r\n");
}//main